using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Sincronizacion;
using Exferia_EntityFramework;
using Exferia_Formularios;
using Exferia_General;
using Exferia_Maestros._1_Datos;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Exferia_Maestros._3_Vistas.Controladoras
{
    public class P_ArticuloComodin_Controladora
    {
        #region Variables Generales
        private P_ArticuloComodin g_frm_P_ArticuloComodin = null;//Variable que enlaza con la pantalla asociada
        private PE_Esperando g_frm_PE_Esperando;//Pantalla de Espera, para cuando se ejecutan tareas pesadas como cargar, guardar, etc

        //Clases de Negocio Necesarias para la carga de datos
        private MAE_ArticulosComodin_Datos g_obj_MAE_ArticulosComodin_Datos = new MAE_ArticulosComodin_Datos();

        public MAE_ArticulosComodin g_mdl_MAE_ArticulosComodin = null;//Modelo de los datos del ArticuloComodin, cargados
        
        public bool g_bol_Termino_CargaDatos_Inicial = false;//Se utiliza para saber cuando se termina la carga de datos estaticos inciales

        //Tareea Asincrona de carga de datos
        private BackgroundWorker g_obj_TareaAsincrona_CargarDatos;
        
        //Tareea Asincrona de grabar de datos
        private BackgroundWorker g_obj_TareaAsincrona_GrabarDatos;
        private bool g_bol_GrabarDatos_TerminoCorrectamente = true;
        private bool g_bol_GrabarDatos_VolverListado = true;

        //Tareea Asincrona de borrar de datos
        private BackgroundWorker g_obj_TareaAsincrona_BorrarDatos;
        private bool g_bol_BorrarDatos_VolverListado = true;

        public bool g_bol_CampoCodigo_Numerico = false;
        #endregion

        #region Constructor
        public P_ArticuloComodin_Controladora(P_ArticuloComodin _frm_P_ArticuloComodin)
        {
            g_frm_P_ArticuloComodin = _frm_P_ArticuloComodin;
            Rellenar_ArbolSecundarioSeleccion();
            g_bol_Termino_CargaDatos_Inicial = true;
        }
        #endregion

        #region Datos Iniciales
        private void Rellenar_ArbolSecundarioSeleccion()
        {
            try
            {
                List<INTERNO_ArbolSecundarioSeleccion_Modelo> lst_INTERNO_ArbolSecundarioSeleccion_Modelo_FINAL = new List<INTERNO_ArbolSecundarioSeleccion_Modelo>();

                //Articulo
                lst_INTERNO_ArbolSecundarioSeleccion_Modelo_FINAL.AddRange(Variables.G_LST_ARBOLSECUNDARIOSELECCION_ARTICULOCOMODIN);

                //Cargar los valores
                g_frm_P_ArticuloComodin.Exferia_ArbolSecundarioSeleccion_ArticuloComodin.Cargar(lst_INTERNO_ArbolSecundarioSeleccion_Modelo_FINAL, g_frm_P_ArticuloComodin.P_Base_ValoresGenerales, g_frm_P_ArticuloComodin.P_Base_FechaTrabajo, g_frm_P_ArticuloComodin);

            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ArticuloComodin_Controladora) + "/" + nameof(Rellenar_ArbolSecundarioSeleccion));
            }
        }
        #endregion

        #region Vaciar Datos
        public void VaciarDatos()
        {
            //Codigo
            g_frm_P_ArticuloComodin.Exferia_TextBox_Codigo.Text = "";
            //Descripcion
            g_frm_P_ArticuloComodin.Exferia_TextBox_Descripcion.Text = "";
            //TipoImpuesto
            g_frm_P_ArticuloComodin.Exferia_F3_TipoImpuesto.Exferia_F3_Id = -1;
            g_frm_P_ArticuloComodin.Exferia_F3_TipoImpuesto.Exferia_F3_Codigo = "";
            g_frm_P_ArticuloComodin.Exferia_F3_TipoImpuesto.Exferia_F3_Descripcion = "";
            g_frm_P_ArticuloComodin.Exferia_F3_TipoImpuesto.Exferia_F3_FechaBorrado = null;
            //TipoRetencion_Venta
            g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Venta.Exferia_F3_Id = -1;
            g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Venta.Exferia_F3_Codigo = "";
            g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Venta.Exferia_F3_Descripcion = "";
            g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Venta.Exferia_F3_FechaBorrado = null;
            //TipoRetencion_Compra
            g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Compra.Exferia_F3_Id = -1;
            g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Compra.Exferia_F3_Codigo = "";
            g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Compra.Exferia_F3_Descripcion = "";
            g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Compra.Exferia_F3_FechaBorrado = null;
            //Nomenclatura_Ventas_PorDefecto
            g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Ventas_PorDefecto.Exferia_F3_Id = -1;
            g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Ventas_PorDefecto.Exferia_F3_Codigo = "";
            g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Ventas_PorDefecto.Exferia_F3_Descripcion = "";
            g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Ventas_PorDefecto.Exferia_F3_FechaBorrado = null;
            //Nomenclatura_Compras_PorDefecto
            g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Compras_PorDefecto.Exferia_F3_Id = -1;
            g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Compras_PorDefecto.Exferia_F3_Codigo = "";
            g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Compras_PorDefecto.Exferia_F3_Descripcion = "";
            g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Compras_PorDefecto.Exferia_F3_FechaBorrado = null;

            string[] str_Separador = new string[] { " [" };
            //Si ya hay valores de objeto, los elimino para rellenarlos de nuevo
            if (g_frm_P_ArticuloComodin.P_Base_TituloPantalla.Split(str_Separador, StringSplitOptions.None).Count() > 1)
            {
                g_frm_P_ArticuloComodin.P_Base_TituloPantalla = (g_frm_P_ArticuloComodin.P_Base_TituloPantalla.Split(str_Separador, StringSplitOptions.None))[0];
            }

            //Actualizar el Boton de Seleccion de pantalla ####################################################
            Variables.G_EMS_CONTROL_MENUSUPERIOR.Update_Texto_NombrePantalla(g_frm_P_ArticuloComodin.Tag.ToString());
            //#################################################################################################

            g_mdl_MAE_ArticulosComodin = null;
        }
        #endregion

        #region Buscar Codigo Siguiente
        public INTERNO_ValorDevuelto_Modelo Buscar_CodigoSiguiente()
        {
            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                MAE_ArticulosComodin obj_MAE_ArticulosComodin;

                string str_CodigoSiguiente = Datos_Generales.Buscar_CodigoSiguiente(nameof(MAE_ArticulosComodin),
                                                                                    nameof(obj_MAE_ArticulosComodin.codigo),
                                                                                    nameof(obj_MAE_ArticulosComodin.idEmpresa),
                                                                                    g_mdl_MAE_ArticulosComodin != null ? g_mdl_MAE_ArticulosComodin.idEmpresa : Datos_Generales.GEN_Empresas_Devolver_IdEmpresa_AGrabar(g_frm_P_ArticuloComodin.P_Base_ValoresGenerales.lng_idEmpresa, nameof(MAE_ArticulosComodin)),
                                                                                    true,
                                                                                    g_frm_P_ArticuloComodin.Exferia_TextBox_Codigo.Exferia_TextBox_MaxLength);

                if (!str_CodigoSiguiente.Equals("-1"))
                {
                    g_frm_P_ArticuloComodin.Exferia_TextBox_Codigo.Text = str_CodigoSiguiente;
                }
                else
                {
                    mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_CODIGOSIGUIENTE_LIMITEALCANZADO(g_frm_P_ArticuloComodin.Exferia_Label_Codigo.Text);
                }

            }
            catch (Control_Errores)
            {
                mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BUSCARCODIGOSIGUIENTE();
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ArticuloComodin_Controladora) + "/" + nameof(Buscar_CodigoSiguiente));
                mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BUSCARCODIGOSIGUIENTE();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Comprobacion de cambios, para  grabar o no antes de salir o cambiar de registro
        public bool ComprobarCambios()
        {
            if (g_frm_P_ArticuloComodin.P_Base_SeModificoDatosPantalla)
            {
                if (Mensajes.MostrarMensaje_Pregunta(Mensajes.G_STR_MENSAJES_GENERAL_PREGUNTA_GUARDARCAMBIOS()))
                {
                    GrabarDatos(false);

                    //Te quedas espernado a que termine la tarea asincrona de grabar
                    while (g_obj_TareaAsincrona_GrabarDatos.IsBusy)
                        Application.DoEvents();

                    return g_bol_GrabarDatos_TerminoCorrectamente;
                }
            }
            return true;
        }
        #endregion

        #region Cargar Datos
        public void RecargarDatos()
        {
            try
            {
                //Bloquear el formulario para que no se pueda hacer nada hasta que termine
                g_frm_P_ArticuloComodin.Enabled = false;

                //Mostrar la pantalla de espera
                g_frm_PE_Esperando = new PE_Esperando();

                // Si la tarea asincrona esta en marcha la paro
                if (g_obj_TareaAsincrona_CargarDatos != null)
                {
                    while (g_obj_TareaAsincrona_CargarDatos.IsBusy)
                        Application.DoEvents();

                    //Vaciar
                    VaciarDatos();
                }
                else
                {
                    g_obj_TareaAsincrona_CargarDatos = new BackgroundWorker();
                    g_obj_TareaAsincrona_CargarDatos.DoWork += new DoWorkEventHandler(TareaAsincrona_CargarDatos_DoWork);
                    g_obj_TareaAsincrona_CargarDatos.ProgressChanged += new ProgressChangedEventHandler(TareaAsincrona_CargarDatos_ProgressChanged);
                    g_obj_TareaAsincrona_CargarDatos.RunWorkerCompleted += new RunWorkerCompletedEventHandler(TareaAsincrona_CargarDatos_Completed);
                    g_obj_TareaAsincrona_CargarDatos.WorkerReportsProgress = true;
                }

                //(Tarea Asincrona) Cargar Datos ##################################################################
                g_obj_TareaAsincrona_CargarDatos.RunWorkerAsync();
                //#################################################################################################

                g_frm_PE_Esperando.ShowDialog();
            }
            catch (Exception ex)
            {
                g_frm_P_ArticuloComodin.Enabled = true;

                if (g_frm_PE_Esperando != null)
                {
                    g_frm_PE_Esperando.Close();
                    g_frm_PE_Esperando = null;
                }

                throw new Control_Errores(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA(), ex, nameof(P_ArticuloComodin_Controladora) + "/" + nameof(RecargarDatos), true);
            }
        }
        private void TareaAsincrona_CargarDatos_DoWork(object sender, DoWorkEventArgs e)
        {
            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                // Cargar Valores
                if (CargarDatos(g_frm_P_ArticuloComodin.P_Base_id) == false)
                {
                    mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA();
                }
            }
            catch (ThreadAbortException ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ArticuloComodin_Controladora) + "/" + nameof(TareaAsincrona_CargarDatos_DoWork));
                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA();
            }
            catch (Control_Errores)
            {
                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA();
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ArticuloComodin_Controladora) + "/" + nameof(TareaAsincrona_CargarDatos_DoWork));
                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA();
            }
            finally
            {
                e.Result = mdl_ValorDevuelto_Modelo;
            }
        }
        private void TareaAsincrona_CargarDatos_ProgressChanged(object sender, ProgressChangedEventArgs e)
        {
            try
            {}
            catch (Exception ex)
            {

                Control_Errores.Errores_Log("", ex, nameof(P_ArticuloComodin_Controladora) + "/" + nameof(TareaAsincrona_CargarDatos_ProgressChanged));
            }
        }
        private void TareaAsincrona_CargarDatos_Completed(object sender, RunWorkerCompletedEventArgs e)
        {
            if (g_frm_PE_Esperando != null)
            {
                g_frm_PE_Esperando.Close();
                g_frm_PE_Esperando = null;
            }
            //Desbloquear el Formulario
            g_frm_P_ArticuloComodin.Enabled = true;

            try
            {
                INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo_Resultado = (INTERNO_ValorDevuelto_Modelo)e.Result;

                //Mostrar si tuviera algun mensaje
                if (mdl_ValorDevuelto_Modelo_Resultado.TodoCorrecto == false)
                {
                    Mensajes.MostrarMensaje(mdl_ValorDevuelto_Modelo_Resultado.Mensaje);
                    g_frm_P_ArticuloComodin.Salir_P_Base();
                }
                else
                {
                    g_frm_P_ArticuloComodin.Exferia_ArbolSecundarioSeleccion_ArticuloComodin.RecargarSeleccionNodo();
                }
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ArticuloComodin_Controladora) + "/" + nameof(TareaAsincrona_CargarDatos_Completed));
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());

                g_frm_P_ArticuloComodin.Salir_P_Base();
            }
            finally
            {

                //Hacemos foco al primer control.
                g_frm_P_ArticuloComodin.Exferia_TextBox_Codigo.Exferia_TextBox_Foco();
            }
        }
        public bool CargarDatos(long _lng_id)
        {
            bool bol_ValorDevuelto = true;

            try
            {
                g_mdl_MAE_ArticulosComodin = g_obj_MAE_ArticulosComodin_Datos.Obtener(_lng_id);
               
                //Si no es Nulo Cargo lo Datos
                if (g_mdl_MAE_ArticulosComodin != null)
                {
                    //Paginador ................................................................................
                    if (g_frm_P_ArticuloComodin.P_Base_PantallaOrigen != null &&
                        g_frm_P_ArticuloComodin.P_Base_PantallaOrigen.P_Base_Objetos_Filtrados != null &&
                        g_frm_P_ArticuloComodin.P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.Count > 0)
                    {
                        long lng_id_ParaPaginacion = g_mdl_MAE_ArticulosComodin.id;
                        int int_PaginaDelObjeto = g_frm_P_ArticuloComodin.P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.IndexOf(g_frm_P_ArticuloComodin.P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.Where(n => n.ID.Equals(lng_id_ParaPaginacion)).FirstOrDefault());

                        g_frm_P_ArticuloComodin.g_obj_Funciones_Paginador.SetPaginaActual(int_PaginaDelObjeto);
                        // Asignando al paginador la pagina actual.
                        g_frm_P_ArticuloComodin.Exferia_Paginador_ArticuloComodin.PaginaActual = g_frm_P_ArticuloComodin.g_obj_Funciones_Paginador.GetPaginaActual();
                    }
                    //...........................................................................................

                    //ArbolSecundarioSeleccion Identificadores Necesarios .......................................
                    //idArticuloComodin
                    g_frm_P_ArticuloComodin.Exferia_ArbolSecundarioSeleccion_ArticuloComodin.Exferia_ArbolSecundarioSeleccion_IDARTICULOCOMODIN = g_mdl_MAE_ArticulosComodin.id;
                    //...........................................................................................

                    //Codigo
                    g_frm_P_ArticuloComodin.Exferia_TextBox_Codigo.Text = g_mdl_MAE_ArticulosComodin.codigo;

                    //Descripcion
                    g_frm_P_ArticuloComodin.Exferia_TextBox_Descripcion.Text = g_mdl_MAE_ArticulosComodin.descripcion;

                    // ImpuestosTipos
                    g_frm_P_ArticuloComodin.Exferia_F3_TipoImpuesto.Exferia_F3_Id = g_mdl_MAE_ArticulosComodin.GEN_ImpuestosTipos.id;
                    g_frm_P_ArticuloComodin.Exferia_F3_TipoImpuesto.Exferia_F3_Codigo = g_mdl_MAE_ArticulosComodin.GEN_ImpuestosTipos.codigo;
                    g_frm_P_ArticuloComodin.Exferia_F3_TipoImpuesto.Exferia_F3_Descripcion = g_mdl_MAE_ArticulosComodin.GEN_ImpuestosTipos.descripcion;
                    g_frm_P_ArticuloComodin.Exferia_F3_TipoImpuesto.Exferia_F3_FechaBorrado = g_mdl_MAE_ArticulosComodin.GEN_ImpuestosTipos.fechaBorrado;

                    //RetencionesTipos(Venta)
                    if (g_mdl_MAE_ArticulosComodin.GEN_RetencionesTipos != null)
                    {
                        g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Venta.Exferia_F3_Id = g_mdl_MAE_ArticulosComodin.GEN_RetencionesTipos.id;
                        g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Venta.Exferia_F3_Codigo = g_mdl_MAE_ArticulosComodin.GEN_RetencionesTipos.codigo;
                        g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Venta.Exferia_F3_Descripcion = g_mdl_MAE_ArticulosComodin.GEN_RetencionesTipos.descripcion;
                        g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Venta.Exferia_F3_FechaBorrado = g_mdl_MAE_ArticulosComodin.GEN_RetencionesTipos.fechaBorrado;
                    }
                    else
                    {
                        g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Venta.Exferia_F3_Id = -1;
                        g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Venta.Exferia_F3_Codigo = string.Empty;
                        g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Venta.Exferia_F3_Descripcion = string.Empty;
                        g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Venta.Exferia_F3_FechaBorrado = null;
                    }

                    //RetencionesTipos(Compra)
                    if (g_mdl_MAE_ArticulosComodin.GEN_RetencionesTipos1 != null)
                    {
                        g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Compra.Exferia_F3_Id = g_mdl_MAE_ArticulosComodin.GEN_RetencionesTipos1.id;
                        g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Compra.Exferia_F3_Codigo = g_mdl_MAE_ArticulosComodin.GEN_RetencionesTipos1.codigo;
                        g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Compra.Exferia_F3_Descripcion = g_mdl_MAE_ArticulosComodin.GEN_RetencionesTipos1.descripcion;
                        g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Compra.Exferia_F3_FechaBorrado = g_mdl_MAE_ArticulosComodin.GEN_RetencionesTipos1.fechaBorrado;
                    }
                    else
                    {
                        g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Compra.Exferia_F3_Id = -1;
                        g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Compra.Exferia_F3_Codigo = string.Empty;
                        g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Compra.Exferia_F3_Descripcion = string.Empty;
                        g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Compra.Exferia_F3_FechaBorrado = null;
                    }

                    //NomenclaturasPrecios Ventas
                    g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Ventas_PorDefecto.Exferia_F3_Id = g_mdl_MAE_ArticulosComodin.MAE_NomenclaturasPrecios.id;
                    g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Ventas_PorDefecto.Exferia_F3_Codigo = g_mdl_MAE_ArticulosComodin.MAE_NomenclaturasPrecios.codigo;
                    g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Ventas_PorDefecto.Exferia_F3_Descripcion = g_mdl_MAE_ArticulosComodin.MAE_NomenclaturasPrecios.descripcion;
                    g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Ventas_PorDefecto.Exferia_F3_FechaBorrado = g_mdl_MAE_ArticulosComodin.MAE_NomenclaturasPrecios.fechaBorrado;

                    // NomenclaturasPrecios Compras
                    g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Compras_PorDefecto.Exferia_F3_Id = g_mdl_MAE_ArticulosComodin.MAE_NomenclaturasPrecios1.id;
                    g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Compras_PorDefecto.Exferia_F3_Codigo = g_mdl_MAE_ArticulosComodin.MAE_NomenclaturasPrecios1.codigo;
                    g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Compras_PorDefecto.Exferia_F3_Descripcion = g_mdl_MAE_ArticulosComodin.MAE_NomenclaturasPrecios1.descripcion;
                    g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Compras_PorDefecto.Exferia_F3_FechaBorrado = g_mdl_MAE_ArticulosComodin.MAE_NomenclaturasPrecios1.fechaBorrado;
                    
                    // Mostrar Campo en el Titulo de mantenimiento
                    string str_MenuSuperior_Codigo = "";
                    if (g_frm_P_ArticuloComodin.g_mdl_PRV_OpcionesDetalle != null &&
                        g_frm_P_ArticuloComodin.g_mdl_PRV_OpcionesDetalle.camposMostrar_TituloMantenimiento != null &&
                        g_frm_P_ArticuloComodin.g_mdl_PRV_OpcionesDetalle.camposMostrar_TituloMantenimiento.Trim().Length > 0)
                    {
                        //Obtener el Array de Campos
                        string[] arr_Campos = g_frm_P_ArticuloComodin.g_mdl_PRV_OpcionesDetalle.camposMostrar_TituloMantenimiento.Split(new Char[] { ',' });
                        string str_ValorAMostrarFinal = "";


                        string[] str_Separador = new string[] { " [" };
                        //Si ya hay valores de objeto, los elimino para rellenarlos de nuevo
                        if (g_frm_P_ArticuloComodin.P_Base_TituloPantalla.Split(str_Separador, StringSplitOptions.None).Count() > 1)
                        {
                            g_frm_P_ArticuloComodin.P_Base_TituloPantalla = (g_frm_P_ArticuloComodin.P_Base_TituloPantalla.Split(str_Separador, StringSplitOptions.None))[0];
                        }

                        dynamic dnm_Objeto = g_mdl_MAE_ArticulosComodin;
                        foreach (string str_campo in arr_Campos)
                        {
                            var Valor = dnm_Objeto.GetType().GetProperty(str_campo).GetValue(dnm_Objeto, null);
                            if (Valor != null)
                            {
                                str_ValorAMostrarFinal += " " + Valor;
                            }

                            // codigo
                            if (str_campo.Equals(nameof(g_mdl_MAE_ArticulosComodin.codigo)))
                            {
                                str_ValorAMostrarFinal = g_mdl_MAE_ArticulosComodin.codigo;
                            }
                         }
                        if (str_ValorAMostrarFinal != "")
                        {
                            g_frm_P_ArticuloComodin.P_Base_TituloPantalla += " [" + str_ValorAMostrarFinal + "] -Modificar";
                        }
                    }
                    //Actualizar el Boton de Seleccion de pantalla ####################################################
                    Variables.G_EMS_CONTROL_MENUSUPERIOR.Add_Texto_NombrePantalla_Descripciones(g_frm_P_ArticuloComodin.Tag.ToString(), str_MenuSuperior_Codigo);
                    //#################################################################################################

                    g_frm_P_ArticuloComodin.P_Base_SeModificoDatosPantalla = false;
                }
            }
            catch (Control_Errores)
            {
                bol_ValorDevuelto = false;
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ArticuloComodin_Controladora) + "/" + nameof(CargarDatos));
                bol_ValorDevuelto = false;
            }

            return bol_ValorDevuelto;
        }
        #endregion

        #region Grabar Datos
        public void GrabarDatos(bool _bol_VolverAlListado)
        {
            try
            {
                g_bol_GrabarDatos_VolverListado = _bol_VolverAlListado;

                g_bol_GrabarDatos_TerminoCorrectamente = true;

                g_frm_P_ArticuloComodin.Enabled = false;
                g_frm_PE_Esperando = new PE_Esperando(Mensajes.G_STR_ESPERANDO_GRABANDODATOS());

                g_obj_TareaAsincrona_GrabarDatos = new BackgroundWorker();
                g_obj_TareaAsincrona_GrabarDatos.DoWork += new DoWorkEventHandler(TareaAsincrona_GrabarDatos_DoWork);
                g_obj_TareaAsincrona_GrabarDatos.RunWorkerCompleted += new RunWorkerCompletedEventHandler(TareaAsincrona_GrabarDatos_Completed);
                g_obj_TareaAsincrona_GrabarDatos.RunWorkerAsync();

                g_frm_PE_Esperando.ShowDialog();
            }
            catch (Exception ex)
            {
                g_bol_GrabarDatos_TerminoCorrectamente = false;
                if (g_frm_PE_Esperando != null)
                {
                    g_frm_PE_Esperando.Close();
                    g_frm_PE_Esperando = null;
                }
                g_frm_P_ArticuloComodin.Enabled = true;

                Control_Errores.Errores_Log("", ex, nameof(P_ArticuloComodin_Controladora) + "/" + nameof(GrabarDatos));
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_GRABARDATOSPANTALLA());
            }
        }
        private void TareaAsincrona_GrabarDatos_DoWork(object sender, DoWorkEventArgs e)
        {
            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                // Validar Primero
                INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo_VALIDACION = ValidarDatos();
                if (mdl_ValorDevuelto_Modelo_VALIDACION.TodoCorrecto)
                {
                    mdl_ValorDevuelto_Modelo = GrabarDatos_Final();
                }
                else
                {
                    mdl_ValorDevuelto_Modelo = mdl_ValorDevuelto_Modelo_VALIDACION;
                }
            }
            catch (ThreadAbortException ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ArticuloComodin_Controladora) + "/" + nameof(TareaAsincrona_GrabarDatos_DoWork));

                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_GRABARDATOSPANTALLA();
            }
            catch (Control_Errores)
            {
                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_GRABARDATOSPANTALLA();
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ArticuloComodin_Controladora) + "/" + nameof(TareaAsincrona_GrabarDatos_DoWork));

                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_GRABARDATOSPANTALLA();
            }
            finally
            {
                e.Result = mdl_ValorDevuelto_Modelo;
            }
        }
        private void TareaAsincrona_GrabarDatos_Completed(object sender, RunWorkerCompletedEventArgs e)
        {
            if (g_frm_PE_Esperando != null)
            {
                g_frm_PE_Esperando.Close();
                g_frm_PE_Esperando = null;
            }
            g_frm_P_ArticuloComodin.Enabled = true;

            try
            {
                INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo_Resultado = (INTERNO_ValorDevuelto_Modelo)e.Result;

                //Mostrar si tuviera algun mensaje
                if (mdl_ValorDevuelto_Modelo_Resultado.TodoCorrecto == false)
                {
                    if (mdl_ValorDevuelto_Modelo_Resultado.Mensaje.Trim().Length > 0)
                    {
                        Mensajes.MostrarMensaje(mdl_ValorDevuelto_Modelo_Resultado.Mensaje);

                        //Poner el Foco en el objeto que tuvoel problema en validar
                        if (mdl_ValorDevuelto_Modelo_Resultado.Objeto != null)
                        {
                            Funciones.Poner_Foco_Objeto(g_frm_P_ArticuloComodin, mdl_ValorDevuelto_Modelo_Resultado.Objeto);
                        }
                    }

                    g_bol_GrabarDatos_TerminoCorrectamente = false;
                }
                else
                {
                    #region SINCRONIZACION
                    INTERNO_Sincronizacion_ActualizarRegistro_Modelo mdl_INTERNO_Sincronizacion_ActualizarRegistro_Modelo = new INTERNO_Sincronizacion_ActualizarRegistro_Modelo();
                    mdl_INTERNO_Sincronizacion_ActualizarRegistro_Modelo.tabla = nameof(MAE_ArticulosComodin);
                    mdl_INTERNO_Sincronizacion_ActualizarRegistro_Modelo.idClavePrimaria = mdl_ValorDevuelto_Modelo_Resultado.Id;

                    Sincronizacion_ActualizarRegistro.Sincronizacion_ActualizarRegistro_RESTOTABLAS(mdl_INTERNO_Sincronizacion_ActualizarRegistro_Modelo);
                    #endregion


                    // Devolver al Listado el Row Añadido/Modificado
                    if (g_frm_P_ArticuloComodin.P_Base_PantallaOrigen != null)
                    {
                        g_frm_P_ArticuloComodin.P_Base_PantallaOrigen.P_Base_ActualizarRegistro(mdl_ValorDevuelto_Modelo_Resultado.Id, mdl_ValorDevuelto_Modelo_Resultado.TipoAccion);
                    }
                    else if (g_frm_P_ArticuloComodin.P_Base_F3Origen != null)
                    {
                        g_frm_P_ArticuloComodin.P_Base_F3Origen.Exferia_F3_ActualizarRegistro(mdl_ValorDevuelto_Modelo_Resultado.Id, mdl_ValorDevuelto_Modelo_Resultado.TipoAccion);
                    }

                    if (g_bol_GrabarDatos_VolverListado)
                    {
                        g_frm_P_ArticuloComodin.P_Base_SeModificoDatosPantalla = false;
                        g_frm_P_ArticuloComodin.Salir_P_Base();
                    }
                }
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ArticuloComodin_Controladora) + "/" + nameof(TareaAsincrona_GrabarDatos_Completed));
            }
        }

        public INTERNO_ValorDevuelto_Modelo ValidarDatos()
        {
            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                //Si el codigo esta vacio y se intenta buscar el ultimo numerico y llego al limite de base de datos
                if (g_frm_P_ArticuloComodin.Exferia_TextBox_Codigo.Text.Trim().Length == 0)
                {
                    INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = Buscar_CodigoSiguiente();

                    if (mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto == false)
                    {
                        mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                        mdl_ValorDevuelto_Modelo.Mensaje = mdl_INTERNO_ValorDevuelto_Modelo.Mensaje;
                        mdl_ValorDevuelto_Modelo.Objeto = g_frm_P_ArticuloComodin.Exferia_TextBox_Codigo;
                    }
                }

                // El codigo no puede estar Repetido
                if (mdl_ValorDevuelto_Modelo.TodoCorrecto)
                {
                    string str_Codigo = g_frm_P_ArticuloComodin.Exferia_TextBox_Codigo.Text.Trim();
                    if (g_bol_CampoCodigo_Numerico)
                    {
                        int int_Codigo = int.Parse(str_Codigo);
                        str_Codigo = int_Codigo.ToString();
                    }

                    if (Datos_Generales.Buscar_CodigoRepetido(nameof(MAE_ArticulosComodin), nameof(MAE_ArticulosComodin.codigo), str_Codigo, nameof(MAE_ArticulosComodin.id), (g_mdl_MAE_ArticulosComodin != null ? g_mdl_MAE_ArticulosComodin.id : -1), nameof(MAE_ArticulosComodin.idEmpresa), g_frm_P_ArticuloComodin.P_Base_ValoresGenerales.lng_idEmpresa, true))
                    {
                        mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                        mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_REPETIDO(g_frm_P_ArticuloComodin.Exferia_Label_Codigo.Text);
                        mdl_ValorDevuelto_Modelo.Objeto = g_frm_P_ArticuloComodin.Exferia_TextBox_Codigo;
                    }
                }
            
                // El ImpuestoTipo no puede estar Vacia (Obligatoria)
                if (mdl_ValorDevuelto_Modelo.TodoCorrecto && g_frm_P_ArticuloComodin.Exferia_F3_TipoImpuesto.Exferia_F3_Codigo.Trim().Length == 0 &&
                    g_frm_P_ArticuloComodin.Exferia_F3_TipoImpuesto.Exferia_F3_Descripcion.Trim().Length == 0)
                {
                    mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_VACIO(g_frm_P_ArticuloComodin.Exferia_F3_TipoImpuesto.Exferia_F3_Titulo);
                    mdl_ValorDevuelto_Modelo.Objeto = g_frm_P_ArticuloComodin.Exferia_F3_TipoImpuesto.Exferia_F3_PRINCIPAL_TextBox_Codigo;
                }

                // Si hay ImpuestoTipo validar que es Correcta
                if (mdl_ValorDevuelto_Modelo.TodoCorrecto && (g_frm_P_ArticuloComodin.Exferia_F3_TipoImpuesto.Exferia_F3_Codigo.Trim().Length != 0 ||
                    g_frm_P_ArticuloComodin.Exferia_F3_TipoImpuesto.Exferia_F3_Descripcion.Trim().Length != 0) && g_frm_P_ArticuloComodin.Exferia_F3_TipoImpuesto.Exferia_F3_Id == -1)
                {
                    mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_F3_INCORRECTO(g_frm_P_ArticuloComodin.Exferia_F3_TipoImpuesto.Exferia_F3_Titulo);
                    mdl_ValorDevuelto_Modelo.Objeto = g_frm_P_ArticuloComodin.Exferia_F3_TipoImpuesto.Exferia_F3_PRINCIPAL_TextBox_Codigo;
                }

                // El NomenclaturaPrecio_Compra no puede estar Vacia (Obligatoria)
                if (mdl_ValorDevuelto_Modelo.TodoCorrecto && g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Compras_PorDefecto.Exferia_F3_Codigo.Trim().Length == 0 &&
                    g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Compras_PorDefecto.Exferia_F3_Descripcion.Trim().Length == 0)
                {
                    mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_VACIO(g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Compras_PorDefecto.Exferia_F3_Titulo);
                    mdl_ValorDevuelto_Modelo.Objeto = g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Compras_PorDefecto.Exferia_F3_PRINCIPAL_TextBox_Codigo;
                }

                // Si hay NomenclaturaPrecio_Compra validar que es Correcta
                if (mdl_ValorDevuelto_Modelo.TodoCorrecto && (g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Compras_PorDefecto.Exferia_F3_Codigo.Trim().Length != 0 ||
                    g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Compras_PorDefecto.Exferia_F3_Descripcion.Trim().Length != 0) && g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Compras_PorDefecto.Exferia_F3_Id == -1)
                {
                    mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_F3_INCORRECTO(g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Compras_PorDefecto.Exferia_F3_Titulo);
                    mdl_ValorDevuelto_Modelo.Objeto = g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Compras_PorDefecto.Exferia_F3_PRINCIPAL_TextBox_Codigo;
                }

                // El NomenclaturaPrecio_Venta no puede estar Vacia (Obligatoria)
                if (mdl_ValorDevuelto_Modelo.TodoCorrecto && g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Ventas_PorDefecto.Exferia_F3_Codigo.Trim().Length == 0 &&
                    g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Ventas_PorDefecto.Exferia_F3_Descripcion.Trim().Length == 0)
                {
                    mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_VACIO(g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Ventas_PorDefecto.Exferia_F3_Titulo);
                    mdl_ValorDevuelto_Modelo.Objeto = g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Ventas_PorDefecto.Exferia_F3_PRINCIPAL_TextBox_Codigo;
                }

                // Si hay NomenclaturaPrecio_Venta validar que es Correcta
                if (mdl_ValorDevuelto_Modelo.TodoCorrecto && (g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Ventas_PorDefecto.Exferia_F3_Codigo.Trim().Length != 0 ||
                    g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Ventas_PorDefecto.Exferia_F3_Descripcion.Trim().Length != 0) && g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Ventas_PorDefecto.Exferia_F3_Id == -1)
                {
                    mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_F3_INCORRECTO(g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Ventas_PorDefecto.Exferia_F3_Titulo);
                    mdl_ValorDevuelto_Modelo.Objeto = g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Ventas_PorDefecto.Exferia_F3_PRINCIPAL_TextBox_Codigo;
                }

                //Si hay Tipo Retencion (Venta) Validar que es correcta
                if (mdl_ValorDevuelto_Modelo.TodoCorrecto && (g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Venta.Exferia_F3_Codigo.Trim().Length != 0 ||
                    g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Venta.Exferia_F3_Descripcion.Trim().Length != 0) && g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Venta.Exferia_F3_Id == -1)
                {
                    mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_VACIO(g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Venta.Exferia_F3_Titulo);
                    mdl_ValorDevuelto_Modelo.Objeto = g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Venta.Exferia_F3_PRINCIPAL_TextBox_Codigo;
                }

                //Si hay Tipo Retencion (Compra)  Validar que es correcta
                if (mdl_ValorDevuelto_Modelo.TodoCorrecto && (g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Compra.Exferia_F3_Codigo.Trim().Length != 0 ||
                    g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Compra.Exferia_F3_Descripcion.Trim().Length != 0) && g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Compra.Exferia_F3_Id == -1)
                {
                    mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_VACIO(g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Compra.Exferia_F3_Titulo);
                    mdl_ValorDevuelto_Modelo.Objeto = g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Compra.Exferia_F3_PRINCIPAL_TextBox_Codigo;
                }
            }
            catch (Control_Errores)
            {
                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_VALIDARDATOSPANTALLA();
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ArticuloComodin_Controladora) + "/" + nameof(ValidarDatos));

                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_VALIDARDATOSPANTALLA();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        private INTERNO_ValorDevuelto_Modelo GrabarDatos_Final()
        {
            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
           
            try
            {

                MAE_ArticulosComodin mdl_MAE_ArticulosComodin = new MAE_ArticulosComodin();
                mdl_MAE_ArticulosComodin.id = g_mdl_MAE_ArticulosComodin != null ? g_mdl_MAE_ArticulosComodin.id : -1;

                //Asignar el idEmpresa...........................................................................................
                if ((g_mdl_MAE_ArticulosComodin != null ? g_mdl_MAE_ArticulosComodin.idEmpresa : -1) != -1)
                {
                    mdl_MAE_ArticulosComodin.idEmpresa = g_mdl_MAE_ArticulosComodin.idEmpresa;
                }
                else
                {
                    //Buscar el idEmpresa que Corresponda
                    mdl_MAE_ArticulosComodin.idEmpresa = Datos_Generales.GEN_Empresas_Devolver_IdEmpresa_AGrabar(g_frm_P_ArticuloComodin.P_Base_ValoresGenerales.lng_idEmpresa, nameof(MAE_ArticulosComodin));
                }

                // Codigo
                mdl_MAE_ArticulosComodin.codigo = g_frm_P_ArticuloComodin.Exferia_TextBox_Codigo.Text.Trim();

                //Descripcion
                mdl_MAE_ArticulosComodin.descripcion = g_frm_P_ArticuloComodin.Exferia_TextBox_Descripcion.Text.Trim();

                //idImpuestoTipo 
                mdl_MAE_ArticulosComodin.idImpuestoTipo = g_frm_P_ArticuloComodin.Exferia_F3_TipoImpuesto.Exferia_F3_Id;

                //idNomenclaturaPrecio_Venta_PorDefecto 
                mdl_MAE_ArticulosComodin.idNomenclaturaPrecio_Venta_PorDefecto = g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Ventas_PorDefecto.Exferia_F3_Id;

                //idNomenclaturaPrecio_Compra_PorDefecto 
                mdl_MAE_ArticulosComodin.idNomenclaturaPrecio_Compra_PorDefecto = g_frm_P_ArticuloComodin.Exferia_F3_Nomenclatura_Compras_PorDefecto.Exferia_F3_Id;

                //idRetencionTipo_Venta
                if (g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Venta.Exferia_F3_Id != -1)
                {
                    mdl_MAE_ArticulosComodin.idRetencionTipo_Venta = g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Venta.Exferia_F3_Id;
                }
                else mdl_MAE_ArticulosComodin.idRetencionTipo_Venta = null;

                //idRetencionTipo_Compra
                if (g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Compra.Exferia_F3_Id != -1)
                {
                    mdl_MAE_ArticulosComodin.idRetencionTipo_Compra = g_frm_P_ArticuloComodin.Exferia_F3_TipoRetencion_Compra.Exferia_F3_Id;
                }
                else mdl_MAE_ArticulosComodin.idRetencionTipo_Compra = null;

                // Se graba el modelo ya relleno.
                mdl_ValorDevuelto_Modelo = g_obj_MAE_ArticulosComodin_Datos.Grabar(mdl_MAE_ArticulosComodin);

            }
            catch (Control_Errores)
            {
                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_GRABARDATOSPANTALLA();
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ArticuloComodin_Controladora) + "/" + nameof(GrabarDatos_Final));
                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_GRABARDATOSPANTALLA();
            }
            
            return mdl_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar Datos
        public void BorrarDatos(bool _bol_VolverAlListado)
        {
            try
            {
                // Preguntar si esta Seguro de Borrar
                if (Mensajes.MostrarMensaje_Pregunta(Mensajes.G_STR_MENSAJES_GENERAL_PREGUNTA_BORRAR()))
                {
                    g_bol_BorrarDatos_VolverListado = _bol_VolverAlListado;
                    g_frm_P_ArticuloComodin.Enabled = false;
                    g_frm_PE_Esperando = new PE_Esperando(Mensajes.G_STR_ESPERANDO_BORRANDODATOS());

                    g_obj_TareaAsincrona_BorrarDatos = new BackgroundWorker();
                    g_obj_TareaAsincrona_BorrarDatos.DoWork += new DoWorkEventHandler(TareaAsincrona_BorrarDatos_DoWork);
                    g_obj_TareaAsincrona_BorrarDatos.RunWorkerCompleted += new RunWorkerCompletedEventHandler(TareaAsincrona_BorrarDatos_Completed);
                    g_obj_TareaAsincrona_BorrarDatos.RunWorkerAsync();

                    g_frm_PE_Esperando.ShowDialog();
                }
            }
            catch (Exception ex)
            {
                if (g_frm_PE_Esperando != null)
                {
                    g_frm_PE_Esperando.Close();
                    g_frm_PE_Esperando = null;
                }

                g_frm_P_ArticuloComodin.Enabled = true;

                Control_Errores.Errores_Log("", ex, nameof(P_ArticuloComodin_Controladora) + "/" + nameof(BorrarDatos));
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BORRARDATOSPANTALLA());
            }
        }
        private void TareaAsincrona_BorrarDatos_DoWork(object sender, DoWorkEventArgs e)
        {
            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                // Borrar 
                mdl_ValorDevuelto_Modelo = BorrarDatos_Final();
            }
            catch (ThreadAbortException ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ArticuloComodin_Controladora) + "/" + nameof(TareaAsincrona_BorrarDatos_DoWork));

                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BORRARDATOSPANTALLA();
            }
            catch (Control_Errores)
            {
                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BORRARDATOSPANTALLA();
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ArticuloComodin_Controladora) + "/" + nameof(TareaAsincrona_BorrarDatos_DoWork));

                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BORRARDATOSPANTALLA();
            }
            finally
            {
                e.Result = mdl_ValorDevuelto_Modelo;
            }
        }
        private void TareaAsincrona_BorrarDatos_Completed(object sender, RunWorkerCompletedEventArgs e)
        {
            if (g_frm_PE_Esperando != null)
            {
                g_frm_PE_Esperando.Close();
                g_frm_PE_Esperando = null;
            }
            g_frm_P_ArticuloComodin.Enabled = true;

            try
            {
                INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo_Resultado = (INTERNO_ValorDevuelto_Modelo)e.Result;

                //Mostrar si tuviera algun mensaje
                if (mdl_ValorDevuelto_Modelo_Resultado.TodoCorrecto == false)
                {
                    if (mdl_ValorDevuelto_Modelo_Resultado.Mensaje.Trim().Length > 0)
                    {
                        Mensajes.MostrarMensaje(mdl_ValorDevuelto_Modelo_Resultado.Mensaje);
                    }
                }
                else
                {
                    #region SINCRONIZACION
                    INTERNO_Sincronizacion_ActualizarRegistro_Modelo mdl_INTERNO_Sincronizacion_ActualizarRegistro_Modelo = new INTERNO_Sincronizacion_ActualizarRegistro_Modelo();
                    mdl_INTERNO_Sincronizacion_ActualizarRegistro_Modelo.tabla = nameof(MAE_ArticulosComodin);
                    mdl_INTERNO_Sincronizacion_ActualizarRegistro_Modelo.idClavePrimaria = mdl_ValorDevuelto_Modelo_Resultado.Id;

                    Sincronizacion_ActualizarRegistro.Sincronizacion_ActualizarRegistro_RESTOTABLAS(mdl_INTERNO_Sincronizacion_ActualizarRegistro_Modelo);
                    #endregion

                    // Devolver al Listado el Row Borrar
                    if (g_frm_P_ArticuloComodin.P_Base_PantallaOrigen != null)
                    {
                        g_frm_P_ArticuloComodin.P_Base_PantallaOrigen.P_Base_ActualizarRegistro(mdl_ValorDevuelto_Modelo_Resultado.Id, mdl_ValorDevuelto_Modelo_Resultado.TipoAccion);
                    }
                    else if (g_frm_P_ArticuloComodin.P_Base_F3Origen != null)
                    {
                        g_frm_P_ArticuloComodin.P_Base_F3Origen.Exferia_F3_ActualizarRegistro(mdl_ValorDevuelto_Modelo_Resultado.Id, mdl_ValorDevuelto_Modelo_Resultado.TipoAccion);
                    }

                    if (g_bol_BorrarDatos_VolverListado)
                    {
                        g_frm_P_ArticuloComodin.P_Base_SeModificoDatosPantalla = false;
                        g_frm_P_ArticuloComodin.Salir_P_Base();
                    }
                }
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ArticuloComodin_Controladora) + "/" + nameof(TareaAsincrona_BorrarDatos_Completed));
            }
        }
        private INTERNO_ValorDevuelto_Modelo BorrarDatos_Final()
        {
            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();

            try
            {
                mdl_ValorDevuelto_Modelo = g_obj_MAE_ArticulosComodin_Datos.Borrar(g_mdl_MAE_ArticulosComodin != null ? g_mdl_MAE_ArticulosComodin.id : -1);
            }
            catch (Control_Errores)
            {
                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BORRARDATOSPANTALLA();
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ArticuloComodin_Controladora) + "/" + nameof(BorrarDatos_Final));
                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BORRARDATOSPANTALLA();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        #endregion
    }
}

